/* 
Webcam PPM Parser
by Javantea aka. Joel R. Voss <jvoss@myuw.net>
Sept 16, 2006
Description
Input ppm files from modified transcode export_ppm2 using a named pipe.
Output data.
*/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
/*
#include <string.h>
#include <sys/types.h> 
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
*/

void error(char *msg)
{
	perror(msg);
	exit(1);
}

int main(int argc, char *argv[])
{
	char *filename = "data/webc2.ppm";
	int height = 288;
	int width  = 352;
	int bpp    = 3;
	if(argc > 1)
	{
		filename = argv[1];
	}
	if(argc > 2)
	{
		width = atoi(argv[2]);
	}
	if(argc > 3)
	{
		height = atoi(argv[3]);
	}
	if(argc > 4)
	{
		bpp = atoi(argv[4]);
	}
	printf("Webcam PPM Parser\n");
	printf("Reading %s (%ix%ix%i) repeatedly.\n", filename, width, height, bpp);
	char frame1[width * height * bpp];
	char frame2[width * height * bpp];
	char *curr_frame = frame1, *prev_frame = frame2, *tmp_frame = 0;
	char header[256];
	header[255] = 0;
	while(1)
	{
		printf("Reopening %s.\n", filename);
		FILE *file = fopen(filename, "rb");
		while(!feof(file))
		{
			fgets(header, 255, file);
			if(feof(file)) break;
			printf("1: %s", header);
			fgets(header, 255, file);
			printf("2: %s", header);
			fgets(header, 255, file);
			printf("3: %s", header);
			fread(curr_frame, width * height * bpp, 1, file);
			
			// Do the math here.
			
			// Double buffer system, no strcpy necessary.
			tmp_frame = curr_frame;
			curr_frame = prev_frame;
			prev_frame = tmp_frame;
		}
		fclose(file);
		//return 0;
	}
	// Never actually gets here unless the while loop breaks.
	return 1;
}
